package com.junmp.junmpProcess.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import com.junmp.junmpProcess.service.Bussiness.OrgUserAndDeptService;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @author : willian fu
 * @version : 1.0
 */
@RestController
@RequestMapping("/OrgUserAndDept")
@Api(tags = "和用户组织机构有关的接口")
public class OrgUserAndDeptController {

    @Resource
    private OrgUserAndDeptService orgService;

    /**
     * 查询组织架构树
     *
     * @param deptId 部门id
     * @return 组织架构树数据
     */
    @ApiOperation("查询组织架构树")
    @GetMapping("tree")
//    @PermissionData(pageComponent = "jeecg/JeecgDemoList")
    public Object getOrgTreeData(@RequestParam(defaultValue = "0") Integer deptId,
                                 @RequestParam(defaultValue = "user") String type
    ) {
        return orgService.getOrgTreeData(deptId, type);
    }

    /**
     * 模糊搜索用户
     *
     * @param userName 用户名/拼音/首字母
     * @return 匹配到的用户
     */
    @ApiOperation("模糊搜索用户")
    @GetMapping("tree/search")
    public Object getOrgTreeUser(@RequestParam String userName) {
        return orgService.getOrgTreeUser(userName.trim());
    }

}
